JUCE: AudioProcessor::Bus Class Reference

JUCE

Public Member Functions | List of all members
AudioProcessor::Bus Class Reference
juce_audio_processors » processors

Describes the layout and properties of an audio bus. More...

`#include <juce_AudioProcessor.h>`

## Public Member Functions
bool | isInput () const noexcept
| Returns true if this bus is an input bus. More...
int | getBusIndex () const noexcept
| Returns the index of this bus. More...
bool | isMain () const noexcept
| Returns true if the current bus is the main input or output bus. More...
const String & | getName () const noexcept
| The bus's name. More...
const AudioChannelSet & | getDefaultLayout () const noexcept
| Get the default layout of this bus. More...
const AudioChannelSet & | getCurrentLayout () const noexcept
| The bus's current layout. More...
const AudioChannelSet & | getLastEnabledLayout () const noexcept
| Return the bus's last active channel layout. More...
bool | setCurrentLayout (const AudioChannelSet &layout)
| Sets the bus's current layout. More...
bool | setCurrentLayoutWithoutEnabling (const AudioChannelSet &layout)
| Sets the bus's current layout without changing the enabled state. More...
int | getNumberOfChannels () const noexcept
| Return the number of channels of the current bus. More...
bool | setNumberOfChannels (int channels)
| Set the number of channels of this bus. More...
bool | isLayoutSupported (const AudioChannelSet &set, BusesLayout *currentLayout=nullptr) const
| Checks if a particular layout is supported. More...
bool | isNumberOfChannelsSupported (int channels) const
| Checks if this bus can support a given number of channels. More...
AudioChannelSet | supportedLayoutWithChannels (int channels) const
| Returns a ChannelSet that the bus supports with a given number of channels. More...
int | getMaxSupportedChannels (int limit=AudioChannelSet::maxChannelsOfNamedLayout) const
| Returns the maximum number of channels that this bus can support. More...
BusesLayout | getBusesLayoutForLayoutChangeOfBus (const AudioChannelSet &set) const
| Returns the resulting layouts of all buses after changing the layout of this bus. More...
bool | isEnabled () const noexcept
| Returns true if the current bus is enabled. More...
bool | enable (bool shouldEnable=true)
| Enable or disable this bus. More...
bool | isEnabledByDefault () const noexcept
| Returns if this bus is enabled by default. More...
int | getChannelIndexInProcessBlockBuffer (int channelIndex) const noexcept
| Returns the position of a bus's channels within the processBlock buffer. More...
template<typename FloatType >
AudioBuffer< FloatType > | getBusBuffer (AudioBuffer< FloatType > &processBlockBuffer) const
| Returns an AudioBuffer containing a set of channel pointers for a specific bus. More...

## Detailed Description

Describes the layout and properties of an audio bus.

Effectively a bus description is a named set of channel types.

See also
  AudioChannelSet, AudioProcessor::addBus

## Member Function Documentation

## ◆ isInput()

bool AudioProcessor::Bus::isInput | ( |  | ) | const
| noexcept

Returns true if this bus is an input bus.

## ◆ getBusIndex()

int AudioProcessor::Bus::getBusIndex | ( |  | ) | const
| noexcept

Returns the index of this bus.

## ◆ isMain()

bool AudioProcessor::Bus::isMain | ( |  | ) | const
| noexcept

Returns true if the current bus is the main input or output bus.

## ◆ getName()

const String & AudioProcessor::Bus::getName | ( |  | ) | const
| noexcept

The bus's name.

References gl::name.

## ◆ getDefaultLayout()

const AudioChannelSet & AudioProcessor::Bus::getDefaultLayout | ( |  | ) | const
| noexcept

Get the default layout of this bus.

See also
  AudioChannelSet

## ◆ getCurrentLayout()

const AudioChannelSet & AudioProcessor::Bus::getCurrentLayout | ( |  | ) | const
| noexcept

The bus's current layout.

This will be AudioChannelSet::disabled() if the current layout is disabled.

See also
  AudioChannelSet

## ◆ getLastEnabledLayout()

const AudioChannelSet & AudioProcessor::Bus::getLastEnabledLayout | ( |  | ) | const
| noexcept

Return the bus's last active channel layout.

If the bus is currently enabled then the result will be identical to getCurrentLayout otherwise it will return the last enabled layout.

See also
  AudioChannelSet

## ◆ setCurrentLayout()

bool AudioProcessor::Bus::setCurrentLayout | ( | const AudioChannelSet & | layout | ) |

Sets the bus's current layout.

If the AudioProcessor does not support this layout then this will return false.

See also
  AudioChannelSet

## ◆ setCurrentLayoutWithoutEnabling()

bool AudioProcessor::Bus::setCurrentLayoutWithoutEnabling | ( | const AudioChannelSet & | layout | ) |

Sets the bus's current layout without changing the enabled state.

If the AudioProcessor does not support this layout then this will return false.

See also
  AudioChannelSet

## ◆ getNumberOfChannels()

int AudioProcessor::Bus::getNumberOfChannels | ( |  | ) | const
| noexcept

Return the number of channels of the current bus.

## ◆ setNumberOfChannels()

bool AudioProcessor::Bus::setNumberOfChannels | ( | int | channels | ) |

Set the number of channels of this bus.

This will return false if the AudioProcessor does not support this layout.

## ◆ isLayoutSupported()

bool AudioProcessor::Bus::isLayoutSupported | ( | const AudioChannelSet & | set,
|  | BusesLayout * | currentLayout = `nullptr`
| ) |  | const

Checks if a particular layout is supported.

Parameters

  set | The AudioChannelSet which is to be probed.
  currentLayout | If non-null, pretend that the current layout of the AudioProcessor is currentLayout. On exit, currentLayout will be modified to to represent the buses layouts of the AudioProcessor as if the layout of the receiver had been successfully changed. This is useful as changing the layout of the receiver may change the bus layout of other buses.

See also
  AudioChannelSet

## ◆ isNumberOfChannelsSupported()

bool AudioProcessor::Bus::isNumberOfChannelsSupported | ( | int | channels | ) | const

Checks if this bus can support a given number of channels.

## ◆ supportedLayoutWithChannels()

AudioChannelSet AudioProcessor::Bus::supportedLayoutWithChannels | ( | int | channels | ) | const

Returns a ChannelSet that the bus supports with a given number of channels.

## ◆ getMaxSupportedChannels()

int AudioProcessor::Bus::getMaxSupportedChannels | ( | int | limit = `AudioChannelSet::maxChannelsOfNamedLayout` | ) | const

Returns the maximum number of channels that this bus can support.

Parameters

  limit | The maximum value to return.

## ◆ getBusesLayoutForLayoutChangeOfBus()

BusesLayout AudioProcessor::Bus::getBusesLayoutForLayoutChangeOfBus | ( | const AudioChannelSet & | set | ) | const

Returns the resulting layouts of all buses after changing the layout of this bus.

Changing an individual layout of a bus may also change the layout of all the other buses. This method returns what the layouts of all the buses of the audio processor would be, if you were to change the layout of this bus to the given layout. If there is no way to support the given layout then this method will return the next best layout.

## ◆ isEnabled()

bool AudioProcessor::Bus::isEnabled | ( |  | ) | const
| noexcept

Returns true if the current bus is enabled.

## ◆ enable()

bool AudioProcessor::Bus::enable | ( | bool | shouldEnable = `true` | ) |

Enable or disable this bus.

This will return false if the AudioProcessor does not support disabling this bus.

## ◆ isEnabledByDefault()

bool AudioProcessor::Bus::isEnabledByDefault | ( |  | ) | const
| noexcept

Returns if this bus is enabled by default.

## ◆ getChannelIndexInProcessBlockBuffer()

int AudioProcessor::Bus::getChannelIndexInProcessBlockBuffer | ( | int | channelIndex | ) | const
| noexcept

Returns the position of a bus's channels within the processBlock buffer.

This can be called in processBlock to figure out which channel of the master AudioBuffer maps onto a specific bus's channel.

## ◆ getBusBuffer()

template<typename FloatType >

AudioBuffer< FloatType > AudioProcessor::Bus::getBusBuffer | ( | AudioBuffer< FloatType > & | processBlockBuffer | ) | const

Returns an AudioBuffer containing a set of channel pointers for a specific bus.

This can be called in processBlock to get a buffer containing a sub-group of the master AudioBuffer which contains all the plugin channels.

The documentation for this class was generated from the following file:

- juce_AudioProcessor.h